#include<stdio.h>
#include<stdlib.h>
//M_PI_4gp̂߂̃}N`
#define _USE_MATH_DEFINES
#include<math.h>

//MAXBITS̕ύXŐxϓ
#define MAXBITS 16

int flag;
static double K;
static double Gain;
static double atanTable[MAXBITS];

static double  gain(void);
void initCordic(void);
void cordic(double* x0, double* y0, double* z0);
double sincosCordic(double a, double* cos);
void dec2bin_for_double(double dn, int bitwidth, int fractional_number, int *bn);
void B_D_output(int bitwidth, int fractional_number,int *c_out);


//f[^e[u쐬
//֐
void initCordic()
{
   double t = 1;
   int 	i;
   int bitwidth, fractional_number;
   bitwidth = 16;
   fractional_number = 14;

   //MAXBITS̃e[u쐬
   //printf(" ---------------atanTable----------------\n");
   for (i = 0; i < MAXBITS; ++i){
	    //e[u쐬ɂ͕WCuarnctangp
        atanTable[i] = atan(t);		
        t /= 2;												
		//e[u̕\
		//printf(" atanTable[%d] = %.18e\n",i ,atanTable[i]);
   }
   //printf(" ----------------------------------------\n");

	//l
	Gain = 1/ gain();

}

//cordic֐
void cordic(double* x0, double* y0, double* theta)
{

    double t;
    double x, y, z;
    int i;
	int bitwidth, fractional_number;

    t = 1;
    x = *x0; y = *y0; z = 0;
	bitwidth = 16;
    fractional_number = 14;


	//MAXBITS̐xŌJԂ
    for (i = 0; i < MAXBITS; ++i) {	
        double x1;


		//z >  theta  ̎ifs
        if ( z > *theta) {
			//ϊ
            x1 = x + y*t;	
            y = y - x*t;
            z = z - atanTable[i];
        }
		//z < theta  ̎elses
        else {
			//̏ꍇ͕ϊŐt
            x1 = x - y*t;
            y = y + x*t;
            z = z + atanTable[i];
        }

        x = x1;
        t /= 2;
    }

    *x0 = x;
    *y0 = y;
    *theta = z;
}

//sin cos vZ
double sincosCordic(double a, double* cos)	
{
   //sinϐ
   double sin = 0;
   //cos(0)xWl
   *cos =  Gain;
   cordic(cos, &sin, &a);
   return sin;
}

//QCZop֐
static double  gain()
{
	double x, y, z;
	x = 1;
	y = 0;
	z = 0;
	cordic(&x, &y, &z);
	return x;
}

int main()
{
   //lZpϐ
   double sin_v;
   double theta;
   double cos_v;
   double true_sin_v, true_cos_v;
   double difference;
   double i=1,l=0;
   int sign=0;

   //iϊpϐ
   int  c_out[16];
   int bitwidth, fractional_number;

   //arctan,gain()s
   initCordic();
   flag = 0;
   
   //theta͈̔́@[-/2 : /2]
	//#define M_PI_2     1.57079632679489661923
   //#define M_PI_4     0.785398163397448309616
   
   
   //theta = M_PI_2;
   //theta = M_PI_4 * 3 / 2;
     theta = M_PI_4;
   //theta = M_PI_4 / 2;
   //theta = 0;
   //theta = -M_PI_4 / 2;
   //theta = -M_PI_4;
   //theta = -M_PI_4 * 3 / 2;
   //theta = -M_PI_2;


   //theta = M_PI_2 - M_PI_2 / 128;
   //theta = M_PI_2 - M_PI_2 / 64;
   //theta = M_PI_2 / 128;
   //theta = M_PI_2 / 64;
   //theta = -M_PI_2 / 64;
   //theta = -M_PI_2 / 128;
   //theta = -M_PI_2 + M_PI_2 / 64;
   //theta = -M_PI_2 + M_PI_2 / 128;
   

   //͒lKp
   //theta = theta/M_PI;

   flag = 1;
   sin_v = sincosCordic(theta, &cos_v);

   
   // fixed point singed 16bit (fractional number is 14bit)
   bitwidth = 16;
   fractional_number = 14;

   //-------------------------------------------------------------------
   //Zl(sin)

   // decimal (double) to binary
   dec2bin_for_double(sin_v, bitwidth, fractional_number, c_out);

   //decimal output
   printf("sin (%f) = %.10e\n",theta ,sin_v);

   // binary output
   B_D_output(bitwidth, fractional_number, c_out);

   //-------------------------------------------------------------------
   //^l(sin)
   true_sin_v = sin(theta);

   // decimal (double) to binary
   dec2bin_for_double(true_sin_v, bitwidth, fractional_number, c_out);

   // decimal output
   printf("true sin (%f) = %.10e\n",theta ,true_sin_v);

   // binary output
   B_D_output(bitwidth, fractional_number, c_out);

   //-------------------------------------------------------------------
   //^lƉZl̍(sin)

   //ZlɂȂȂ悤ɒ
   difference = true_sin_v - sin_v;
   if(difference < 0)
	   difference = sin_v - true_sin_v;

   // decimal (double) to binary
   dec2bin_for_double(difference, bitwidth, fractional_number, c_out);

   // decimal output
   printf("difference sin (%f) = %.10e\n",theta ,difference);

   // binary output
   B_D_output(bitwidth, fractional_number, c_out);

   //-------------------------------------------------------------------
   //Zl(cos)

   // decimal (double) to binary
   dec2bin_for_double(cos_v, bitwidth, fractional_number, c_out);

   // decimal output
   printf("cos (%f) = %.10e\n",theta ,cos_v);

   // binary output
   B_D_output(bitwidth, fractional_number, c_out);

   //-------------------------------------------------------------------
   //^l(cos)
   true_cos_v = cos(theta);

   // decimal (double) to binary
   dec2bin_for_double(true_cos_v, bitwidth, fractional_number, c_out);

   // decimal output
   printf("true cos (%f) = %.10e\n",theta ,true_cos_v);

   // binary output
   B_D_output(bitwidth, fractional_number, c_out);

   //-------------------------------------------------------------------
   //^lƉZl̍(cos)

   //ZlɂȂȂ悤ɒ
   difference = true_cos_v - cos_v;
   if(difference < 0)
	   difference = cos_v - true_cos_v;

   // decimal (double) to binary
   dec2bin_for_double(difference, bitwidth, fractional_number, c_out);

   // decimal output
   printf("difference cos (%f) = %.10e\n",theta ,difference);

   // binary output
   B_D_output(bitwidth, fractional_number, c_out);
   //-------------------------------------------------------------------

   //p[^mFp
   //-------------------------------------------------------------------
   //̌Œ菬_
   //decimal (double) to binary
   //dec2bin_for_double(atanTable[14], bitwidth, fractional_number, c_out);
   //binary output
   //B_D_output(bitwidth, fractional_number, c_out);
   //-------------------------------------------------------------------
   //1/ǨŒ菬_
   //decimal (double) to binary
   //l = 1/K;
   //dec2bin_for_double(l, bitwidth, fractional_number, c_out);
   //binary output
   //B_D_output(bitwidth, fractional_number, c_out);
   //-------------------------------------------------------------------
   //decimal (double) to binary
   //dec2bin_for_double(theta, bitwidth, fractional_number, c_out);
   //binary output
   //B_D_output(bitwidth, fractional_number, c_out);
   //-------------------------------------------------------------------
   //deltǎŒ菬_
   //decimal (double) to binary
   //i /= 8;
   //dec2bin_for_double(i, bitwidth, fractional_number, c_out);
   //binary output
   //B_D_output(bitwidth, fractional_number, c_out);
   //-------------------------------------------------------------------

   getchar();										//visualStudiopR\[ҋ@

}

void dec2bin_for_double(double dn, int bitwidth, int fractional_number, int *bn)
{
	int dn_int;
	double shift_v;
	int i;
	int temp_bn;

	//fractional_number̒lVtgsC
	//shift_vɐldouble^Ƃđ
	shift_v = (double)(1 << fractional_number);

	//Zdnshift_vZ(fractional_numberx)
	//܂int^l1,0ŕ\Ă
	dn_int = (int)(dn * shift_v);

	//bitwidthJԂiϊs
	for(i = 0; i < bitwidth; i++)
	{
		//int^ŕ\ꂽ1,0ANDƂ
		temp_bn = dn_int & 0x1;

		bn[i] = temp_bn;
		//i=0őlĂߕ\͋ti[
		dn_int = (dn_int >> 1);
	}
}


void B_D_output(int bitwidth, int fractional_number, int *c_out){
	int j;
	

	// binary output
  	 for( j=bitwidth-1; j>=0; j-- )
  	 {
   	    printf("%1d",c_out[j]);
	
		  if (j == fractional_number)
		   {
			   printf(".");
		   }
   	}	
  	 printf("\n");


}